"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("./utils");
const merge = require("lodash.merge");
const debugGenerator = require("debug");
const debug = debugGenerator('efate:fixture');
function applyOverrides(fixture, overrides) {
    if ((0, utils_1.isFunction)(overrides)) {
        overrides(fixture);
    }
    else {
        merge(fixture, overrides);
    }
}
class Fixture {
    constructor(builders) {
        this.builders = [];
        this.instanceCount = 1;
        this.builders = builders;
    }
    create(overrides = {}) {
        const fixture = {};
        this.builders.forEach((builder) => {
            debug('builder: %o', builder);
            const field = builder(this.instanceCount);
            debug('generated field %o', field);
            Object.defineProperty(fixture, field.name, {
                value: field.value,
                enumerable: true,
                writable: true,
            });
        });
        applyOverrides(fixture, overrides);
        this.instanceCount++;
        return fixture;
    }
}
exports.default = Fixture;
